<template>
<div>
  <Navbar/>
  <b-container id="dashboard">
    <b-row v-if="!is_show_inputs">
      <b-button @click="showDateInputs">Add leave</b-button>
    </b-row>
    <b-row v-if="is_show_inputs">
      <b-col>
        <b-form-datepicker id="start_date" v-model="start_date" class="mb-2"></b-form-datepicker>
      </b-col>
      <b-col v-if="!is_half_day">
        <b-form-datepicker id="end_date" v-model="end_date" class="mb-2"></b-form-datepicker>
      </b-col>
      <b-col>      
      <b-form-checkbox
      id="checkbox-1"
      v-model="is_half_day"
      name="checkbox-1"
    >
      a half day leave
    </b-form-checkbox>  
    </b-col>
    <b-col>
      <b-button id="button" @click="add_leave">Create</b-button>
      <b-button id="button" @click="showDateInputs">Cancel</b-button>
      </b-col>
    </b-row>
    <br>
    <b-row>
      <b-col>
        <b-table
          :items="leaves"
          :fields="fields"
          :sort-by.sync="sortBy"
          :sort-desc.sync="sortDesc"
          sort-icon-left
          responsive="sm"
        >
        <template v-slot:cell(actions)="row">
          <b-dropdown size="sm" id="dropdown-1" text="Actions" >
            <b-dropdown-item v-if="row.item.status=='DRAFT'" @click="send_to_manager(row.item.uuid)"> Send to Manager </b-dropdown-item>
            <b-dropdown-item @click="delete_leave(row.item.uuid)">Delete</b-dropdown-item>
            </b-dropdown>
          </template>

        </b-table>

      </b-col>
    </b-row>
  </b-container>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import Navbar from "./Navbar.vue"
export default {
  name: "Dashboard",
  components: {
    Navbar
  },
  computed: {
    ...mapGetters("leaves", {
      leaves: "leaves"
    })
  },
  data() {
    return {
      sortBy: "start_date",
      sortDesc: false,
      start_date: null,
      end_date: null,
      is_half_day: false,
      is_show_inputs: false,
      fields: [
        { key: "start_date", sortable: true, formatter: (value) => {
              return value.split("T")[0]
            } },
        { key: "end_date", sortable: true,  formatter: (value) => {
              return value.split("T")[0]
            } },
        { key: "days", sortable: true, formatter: (value) => {
              return value/8
            } },
        { key: "status", sortable: true },
        { key: 'actions', label: 'Actions' }
      ]
    };
  },
  mounted: function() {
    this.$store.commit('login/tryToLoadToken')
    this.$store.dispatch("leaves/getLeaves");
  },
  methods: {
    showDateInputs() {
      this.is_show_inputs = !this.is_show_inputs;
    },
    add_leave() {
      this.$store.dispatch("leaves/addLeave", {
        start_date: new Date(this.start_date).toISOString(),
        end_date: new Date(this.end_date).toISOString(),
        is_half: this.is_half_day
      });
    },
    delete_leave(uuid) {
      let bvToast = this.$bvToast
      let data = {
        uuid,
        bvToast
      }
      this.$store.dispatch("leaves/deleteLeave", data);
    },    
    send_to_manager(uuid) {
      let body={status: "REQUESTED"}
      let data = {
        uuid,
        body
      }
      this.$store.dispatch("leaves/updateLeave", data);
    }
  }
};
</script>

<style>
#dashboard {
  margin-top: 60px;
  padding: 25px; 
}
</style>
